variable "name" {
  type        = string
  description = "The name of the Swarm project."
}

variable "env" {
  type        = string
  description = "Deployment environment."
}

variable "jz_vpc" {
  type        = object({
    self    = object({
      id = string
    })
    subnets = list(any)
  })
  description = "A reference to jz_vpc module."
}

variable "jz_swarm_project" {
  type        = object({
    instance_ids = object({
      leader   = string
      managers = set(string)
      workers  = set(string)
    })
  })
  description = "A reference to jz_swarm_project module."
}

/*variable "port_mapping" {
  type = list(object({
    app_schema = string
    app_port   = number
    alb_schema = string
    alb_port   = number
    # host     = string (optional)
  }))
} CANNOT BE USED DUE TO NO "default" POSSIBILITIES FOR "host" */

variable "port_mapping" {
  type = any
  description = "ALB to app ports mapping."
}

variable "redirect_80_to_443" {
  default = false
  description = "If should add http redirect to https."
}

variable "ssl_cert_domain" {
  type        = string
  default     = ""
  description = "ACM certificate domain name (FQN) for which https ELB listeners shall be launched."
}
