resource "docker_network" "nginx-proxy" {
  name       = "nginx-proxy"
  driver     = "overlay"
  attachable = true
}

resource "docker_image" "nginx-proxy" {
  name = "jwilder/nginx-proxy:latest"
}

// TODO label first node with feature-deployment=1

resource "docker_service" "nginx-proxy" {
  name = "nginx-proxy"

  mode {
    replicated {
      replicas = 1
    }
  }

  task_spec {
    container_spec {
      image = docker_image.nginx-proxy.name
      mounts {
        source    = "/var/run/docker.sock"
        target    = "/tmp/docker.sock"
        type      = "bind"
        read_only = true
      }
    }
    placement {
      constraints = [
        "node.labels.feature-deployment==1"]
      platforms {
        architecture = "amd64"
        os           = "linux"
      }
    }
    networks = [
      docker_network.nginx-proxy.id]
  }

  endpoint_spec {
    ports {
      target_port    = 80
      published_port = 81
    }
  }
}
